<template>
    <div class="container">
        <!-- HEADLINE -->
        <h1 class="row col-12 page-title">Advanced Search</h1>
        <button @click="applySearch()" class="ecl-button ecl-button--secondary back-btn mt-3">
            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                class="bi bi-arrow-left-circle" viewBox="0 0 16 16">
                <path fill-rule="evenodd"
                    d="M1 8a7 7 0 1 0 14 0A7 7 0 0 0 1 8m15 0A8 8 0 1 1 0 8a8 8 0 0 1 16 0m-4.5-.5a.5.5 0 0 1 0 1H5.707l2.147 2.146a.5.5 0 0 1-.708.708l-3-3a.5.5 0 0 1 0-.708l3-3a.5.5 0 1 1 .708.708L5.707 7.5z" />
            </svg>
            Back to Quick Search
        </button>
        <!-- DEBUG Container -->
        <div class="debug">
            <strong>Query:</strong> <br>
            {{ query }} {{ titleQuery }} {{ descQuery }}<br> <br>
            <strong>Filters:</strong>
            <br>
            {{ selectedFields }}

            <br><br>
            Type:
            <br>
            {{ this.selectedOption }}

            <br> <br>
            {{ this.locale }}
        </div>
        <!-- COMBINED TAB BAR -->
        <div class="tab-bar mt-4">
            <div class="btn-group">
                <button v-for="option in options" :key="option.value"
                    :class="['btn', option.value === selectedOption ? 'btn-primary active' : 'ecl-button ecl-button--secondary']"
                    @click="selectOption(option.value)">
                    {{ option.label }}
                    <!-- <span class="count-badge">...</span> -->
                </button>
            </div>
        </div>
        <!-- SEARCH BUTTONS -->
        <div class="col d-flex justify-content-end">
                    <button class="ecl-button ecl-button--secondary mr-2" @click="clearAll()">Clear</button>
                    <button class="ecl-button ecl-button--primary" @click="applySearch()">Apply Search</button>
                </div>

        <!-- SEARCH BOX -->
        <div class="mt-5 box">
            <div class="row">
                <div class="col-8">
                    <h2><svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                            class="bi bi-search" viewBox="0 0 16 16">
                            <path
                                d="M11.742 10.344a6.5 6.5 0 1 0-1.397 1.398h-.001q.044.06.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1 1 0 0 0-.115-.1zM12 6.5a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0" />
                        </svg> Search in</h2>

                    <!-- FORM GROUP SEARCH IN -->
                    <div class="form mt-4">
                        <form>
                            <div class="label mb-2">All properties</div>
                            <input type="text" class="text mb-4" v-model="query" placeholder="Search in all properties"
                                id="all"
                                :disabled="descQuery || titleQuery || activeField !== 'all' && activeField !== null"
                                @focus="setActive('all')" :class="{ 'filled-input': query }">

                            <button v-if="query" class="btn" @click="clearInput()"> <svg
                                    xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                                    class="bi bi-x" viewBox="0 0 16 16">
                                    <path
                                        d="M4.646 4.646a.5.5 0 0 1 .708 0L8 7.293l2.646-2.647a.5.5 0 0 1 .708.708L8.707 8l2.647 2.646a.5.5 0 0 1-.708.708L8 8.707l-2.646 2.647a.5.5 0 0 1-.708-.708L7.293 8 4.646 5.354a.5.5 0 0 1 0-.708" />
                                </svg></button>

                            <div class="label mb-2">Title</div>
                            <input type="text" class="text mb-4" v-model="titleQuery" placeholder="Search in Title"
                                id="title"
                                :disabled="query || descQuery || activeField !== 'title' && activeField !== null"
                                @focus="setActive('title')" :class="{ 'filled-input': titleQuery }">

                            <button v-if="titleQuery" class="btn" @click="clearInput()"> <svg
                                    xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                                    class="bi bi-x" viewBox="0 0 16 16">
                                    <path
                                        d="M4.646 4.646a.5.5 0 0 1 .708 0L8 7.293l2.646-2.647a.5.5 0 0 1 .708.708L8.707 8l2.647 2.646a.5.5 0 0 1-.708.708L8 8.707l-2.646 2.647a.5.5 0 0 1-.708-.708L7.293 8 4.646 5.354a.5.5 0 0 1 0-.708" />
                                </svg></button>

                            <div class="label mb-2">Description</div>
                            <input type="text" class="text mb-4" v-model="descQuery" placeholder="Search in Description"
                                id="description"
                                :disabled="query || titleQuery || activeField !== 'description' && activeField !== null"
                                @focus="setActive('description')" :class="{ 'filled-input': descQuery }">


                            <button v-if="descQuery" class="btn" @click="clearInput()"> <svg
                                    xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                                    class="bi bi-x" viewBox="0 0 16 16">
                                    <path
                                        d="M4.646 4.646a.5.5 0 0 1 .708 0L8 7.293l2.646-2.647a.5.5 0 0 1 .708.708L8.707 8l2.647 2.646a.5.5 0 0 1-.708.708L8 8.707l-2.646 2.647a.5.5 0 0 1-.708-.708L7.293 8 4.646 5.354a.5.5 0 0 1 0-.708" />
                                </svg></button>
                        </form>
                    </div>
                </div>

                <!-- INFO BOX-->
                <div class="col-3 info-box">
                    <h3> Search Operators</h3>
                    <div class="details mt-3">
                        <li>AND / OR / NOT</li>
                        <li>"" exact phrase search</li>
                        <li>* replace 0 to n characters</li>
                        <li>? replace a single character</li>
                        <div>
                            <div class="ecl-button ecl-button--secondary btn-more mt-4">
                                <a href="https://dataeuropa.gitlab.io/data-provider-manual/how-to-search/search-for-datasets/"
                                    target="_blank">More Information</a>

                                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                                    class="bi bi-box-arrow-up-right ml-1" viewBox="0 0 16 16">
                                    <path fill-rule="evenodd"
                                        d="M8.636 3.5a.5.5 0 0 0-.5-.5H1.5A1.5 1.5 0 0 0 0 4.5v10A1.5 1.5 0 0 0 1.5 16h10a1.5 1.5 0 0 0 1.5-1.5V7.864a.5.5 0 0 0-1 0V14.5a.5.5 0 0 1-.5.5h-10a.5.5 0 0 1-.5-.5v-10a.5.5 0 0 1 .5-.5h6.636a.5.5 0 0 0 .5-.5" />
                                    <path fill-rule="evenodd"
                                        d="M16 .5a.5.5 0 0 0-.5-.5h-5a.5.5 0 0 0 0 1h3.793L6.146 9.146a.5.5 0 1 0 .708.708L15 1.707V5.5a.5.5 0 0 0 1 0z" />
                                </svg>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

        </div>

        <!-- Date BOX -->
        <div class="mt-4 box">
            <h2>
                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                    class="bi bi-calendar-event" viewBox="0 0 16 16">
                    <path d="M11 6.5a.5.5 0 0 1 .5-.5h1a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-1a.5.5 0 0 1-.5-.5z" />
                    <path
                        d="M3.5 0a.5.5 0 0 1 .5.5V1h8V.5a.5.5 0 0 1 1 0V1h1a2 2 0 0 1 2 2v11a2 2 0 0 1-2 2H2a2 2 0 0 1-2-2V3a2 2 0 0 1 2-2h1V.5a.5.5 0 0 1 .5-.5M1 4v10a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1V4z" />
                </svg> Date
            </h2>

            <!-- FORM GROUP DATE -->
            <div class="form mt-4 date">
                <form>
                    <div class="label mb-2">Created</div>
                    <MonthYearPicker @date-changed="handleDateChange('created')" />

                    <div class="label mb-2">Updated</div>
                    <MonthYearPicker @date-changed="handleDateChange('updated')" />
                </form>
            </div>
        </div>

        <!-- FILTER BOX -->
        <div class="mt-4 box">
            <h2><svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-funnel"
                    viewBox="0 0 16 16">
                    <path
                        d="M1.5 1.5A.5.5 0 0 1 2 1h12a.5.5 0 0 1 .5.5v2a.5.5 0 0 1-.128.334L10 8.692V13.5a.5.5 0 0 1-.342.474l-3 1A.5.5 0 0 1 6 14.5V8.692L1.628 3.834A.5.5 0 0 1 1.5 3.5zm1 .5v1.308l4.372 4.858A.5.5 0 0 1 7 8.5v5.306l2-.666V8.5a.5.5 0 0 1 .128-.334L13.5 3.308V2z" />
                </svg> Filter </h2>
            <!-- Filter  -->

            <div v-for="(groupRow, rowIndex) in chunkArray(getAllAvailableFacets, 3)" :key="rowIndex" class="facet-row">
                <div v-for="group in groupRow" :key="group.id" class="facet-group">
                    <div class="facet-label">
                        <label :for="group.id">{{ group.title }}</label>
                    </div>

                    <!-- Multi select dropdowns -->
                    <div v-if="(group.id !== 'superCatalog' && group.id !== 'dataServices' && group.id !== 'is_hvd')">
                        <div class="multiselect-container">
                            <!-- Dropdown trigger -->
                            <div class="multiselect-trigger" @click="toggleDropdown(group.id)">
                                <span class="trigger-content">
                                    <template v-if="selectedFields[group.id]?.length">
                                        <span class="filter-badge">{{ selectedFields[group.id].length }}</span>
                                        <span class=""> {{ getSelectedLabels(group) }}</span>
                                    </template>
                                    <template v-else>
                                        Select
                                    </template>
                                </span>
                                <div class="ecl-select__icon">
                                    <svg class="ecl-icon ecl-icon--s ecl-icon--rotate-180 ecl-select__icon-shape"
                                        focusable="false" aria-hidden="true">
                                        <use xlink:href="@/assets/img/ecl/icons.svg#corner-arrow"></use>
                                    </svg>
                                </div>
                            </div>

                            <!-- Dropdown content -->
                            <div v-show="openDropdowns[group.id]" class="multiselect-wrapper">
                                <input type="text" v-model="searchQueries[group.id]"
                                    :placeholder="`Filter ${group.title}`" class="multiselect-search" @click.stop />
                                <div class="multiselect-dropdown" @click.stop>
                                    <div v-for="item in filteredItems(group)" :key="item.id" class="multiselect-item">
                                        <label class="checkbox-container">
                                            <input type="checkbox" :value="item.id"
                                                :checked="selectedFields[group.id]?.includes(item.id)"
                                                @change="handleCheckboxChange(group.id, item.id, $event)" />
                                            <span class="checkbox-label">{{ getLocalizedTitle(item.title) }}</span>
                                            <span class="count">{{ item.count }}</span>
                                        </label>
                                    </div>

                                </div>
                                <div class="btn-container">
                                    <button class="ecl-button ecl-button--primary select-custom"
                                        @click="this.closeAllDropdowns()"> Apply </button>
                                    <button class="ecl-button ecl-button--secondary select-custom"
                                        @click="clear(group.id)"> Clear All </button>
                                </div>
                            </div>
                        </div>
                    </div>

                    <!-- Radio Boxex-->
                    <div v-if="(group.id === 'is_hvd')" class="radio">
                        <span>HVDs only</span>
                        <span class="ml-2 d-flex flex-wrap">
                            <div class="radio-options">
                                <input type="radio" name="is_hvd" :value="true" v-model="selectedFields.is_hvd"
                                    :checked="selectedFields.is_hvd[0] === 'true'" />
                                <label class="">
                                    Yes
                                </label>
                            </div>
                            <div class="radio-options">
                                <input type="radio" name="is_hvd" :value="''" v-model="selectedFields.is_hvd"
                                    :checked="selectedFields.is_hvd[0] !== 'true'" />
                                <label class="radio-container">
                                    No
                                </label>
                            </div>
                        </span>
                    </div>

                    <div v-if="(group.id === 'dataServices')" class="radio">
                        <span>Data services</span>
                        <span class="ml-2 d-flex flex-wrap">
                            <div class="radio-options">
                                <input type="radio" name="dataServices" :value="true"
                                    v-model="selectedFields.dataServices"
                                    :checked="selectedFields.dataServices[0] === 'true'" />
                                <label class="">
                                    Yes
                                </label>
                            </div>
                            <div class="radio-options">
                                <input type="radio" name="dataServices" :value="''"
                                    v-model="selectedFields.dataServices"
                                    :checked="selectedFields.dataServices[0] !== 'true'" />
                                <label class="radio-container">
                                    No
                                </label>
                            </div>
                        </span>

                    </div>

                    <!-- New superCatalog radio group -->
                    <div v-if="(group.id === 'superCatalog')" class="radio">
                        <span>ERPD Data only</span>
                        <span class="ml-2 d-flex flex-wrap">
                            <div class="radio-options">
                                <input type="radio" name="dataServices" :value="'erpd'"
                                    v-model="selectedFields.superCatalog"
                                    :checked="selectedFields.superCatalog === 'erpd'" />
                                <label class="">
                                    Yes
                                </label>
                            </div>
                            <div class="radio-options">
                                <input type="radio" name="dataServices" v-model="selectedFields.superCatalog"
                                    :value="''" :checked="selectedFields.superCatalog === ''" />
                                <label class="radio-container">
                                    No
                                </label>
                            </div>
                        </span>
                    </div>
                </div>
            </div>

        </div>
        <div class="mt-4">
            <div class="row">
                <div class="col-9">
                    <button class="ecl-button ecl-button--secondary btn-more">
                        Show API request

                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                            class="bi bi-box-arrow-up-right ml-1" viewBox="0 0 16 16">
                            <path fill-rule="evenodd"
                                d="M8.636 3.5a.5.5 0 0 0-.5-.5H1.5A1.5 1.5 0 0 0 0 4.5v10A1.5 1.5 0 0 0 1.5 16h10a1.5 1.5 0 0 0 1.5-1.5V7.864a.5.5 0 0 0-1 0V14.5a.5.5 0 0 1-.5.5h-10a.5.5 0 0 1-.5-.5v-10a.5.5 0 0 1 .5-.5h6.636a.5.5 0 0 0 .5-.5" />
                            <path fill-rule="evenodd"
                                d="M16 .5a.5.5 0 0 0-.5-.5h-5a.5.5 0 0 0 0 1h3.793L6.146 9.146a.5.5 0 1 0 .708.708L15 1.707V5.5a.5.5 0 0 0 1 0z" />
                        </svg> </button>
                </div>
                <div class="col d-flex justify-content-end">
                    <button class="ecl-button ecl-button--secondary mr-2" @click="clearAll()">Clear</button>
                    <button class="ecl-button ecl-button--primary" @click="applySearch()">Apply Search</button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import {
    helpers,
} from "@piveau/piveau-hub-ui-modules";
import $ from "jquery";
import { has, isArray, isNil } from "lodash-es";
import { mapActions, mapGetters } from "vuex";
import MonthYearPicker from './MonthYearPicker.vue';

const { getTranslationFor, truncate, getImg } = helpers;

export default {
    name: "AdvancedSearch",
    setup() {
        // const route = useRoute();
        // const locale = ref(route.query.locale)
        // const selectedOption = ref('all');  
        // const query = ref('')
        // const titleQuery = ref('')
        // const descQuery = ref('')
        // const selectedFields = ref({});

        // return {
        //     locale,
        //     selectedOption,
        //     query,
        //     titleQuery, 
        //     descQuery,   
        //     selectedFields
        // }
    },

    props: {
        config: Object
    },
    components: {
        MonthYearPicker
    },
    data() {
        return {
            baseUrl: this.$env.api.baseUrl,
            open: false,
            options: [
                { value: 'all', label: 'All', count: '...' },
                { value: 'datasets', label: 'Datasets', count: '...' },
                { value: 'catalogues', label: 'Catalogues', count: '...' },
                { value: 'editorial', label: 'Editorial Content', count: '...' },
            ],
            facetFields: [],
            locale: this.$route.query.locale,
            filterCollapsed: true,
            catalogAllowed: false,
            useCreateDatasetButton: this.$env.content.dataProviderInterface.buttons.Datasets,
            useCreateCatalogueButton: this.$env.content.dataProviderInterface.buttons.Catalogue,
            useDatasetFacets: this.$env.content.datasets.facets.useDatasetFacets,
            activeField: null,
            query: sessionStorage.getItem('query') || '',
            titleQuery: sessionStorage.getItem('titleQuery') || '',
            descQuery: sessionStorage.getItem('descQuery') || '',
            selectedOption: sessionStorage.getItem('selectedOption') || 'all',
            selectedFields: {} || sessionStorage.getItem('selectedFields'),
            isDropdownOpen: false,
            searchQueries: {},
            openDropdowns: {},
        };
    },
    computed: {
        ...mapGetters("datasets", [
            "getDatasets",
            "getDatasetsCount",
            "getFacets",
            "getLimit",
            "getLoading",
            "getOffset",
            "getPage",
            "getPageCount",
            "getAvailableFacets",
            "getAllAvailableFacets",
            "getMinScoring",
        ]),
        savedValue() {
            return sessionStorage.getItem('query'); // Return the query from sessionStorage
        },
        get() {
            return this.modelValue;
        },
        facets() {
            const facets = {};
            for (const field of this.facetFields) {
                let urlFacets;
                if (field === 'catalog' && !isNil(this.$route.params.ctlg_id)) urlFacets = this.$route.params.ctlg_id;
                else urlFacets = this.$route.query[field];
                if (!urlFacets) urlFacets = [];
                else if (!Array.isArray(urlFacets)) urlFacets = [urlFacets];
                facets[field] = urlFacets;
            }
            return facets;
        },
        currentSearchQuery() {
            return this.$route.query.query;
        },
        showScoreDisclaimer() {
            return this.getMinScoring > 0;
        },
        dataScope() {
            if (!this.$route.query.dataScope) return null;
            if (
                isArray(this.$route.query.dataScope) &&
                this.$route.query.dataScope.length > 0
            )
                return this.$route.query.dataScope[0];
            if (
                isArray(this.$route.query.dataScope) &&
                this.$route.query.dataScope.length === 0
            )
                return null;
            return this.$route.query.dataScope;
        },
        isErpdActive() {
            return this.$route.query.superCatalog === 'erpd'
                || this.$route.path === '/catalogues/erpd';
        },
        queryString() {
            return Object.entries(this.selectedFields)
                .filter(([, value]) => value && value.length > 0)
                .map(([key, value]) => `${key}=${value.join(',')}`)
                .join('&')
        }
    },
    watch: {
        facets: {
            handler(facets) {
                this.setFacets(facets);
            },
            deep: true,
        },
        // eslint-disable-next-line object-shorthand
        page(pageStr) {
            const page = parseInt(pageStr, 10);
            if (page > 0) this.setPage(page);
            else this.setPage(1);
        },
        dataScope: {
            handler() {
                this.initDataScope();
            },
            deep: true,
        },
        query(newValue) {
            // Watch for changes to query and save it to sessionStorage
            sessionStorage.setItem('query', newValue);
            if (newValue === '') this.handleEmpty('query');
        },
        titleQuery(newValue) {
            sessionStorage.setItem('titleQuery', newValue);
            if (newValue === '') this.handleEmpty('titleQuery');
        },
        descQuery(newValue) {
            sessionStorage.setItem('descQuery', newValue);
            if (newValue === '') this.handleEmpty('descQuery');
        },
        selectedOptionType(newValue) {
            // Save the selected option to session storage when it changes
            sessionStorage.setItem('selectedOption', newValue);
        },
        selectedFilters(newValue) {
            // Save the selected option to session storage when it changes
            sessionStorage.setItem('selectedFields', newValue);
        },
        selectedFields: {
            handler(newValue) {
                // Save updated selectedFields to sessionStorage
                sessionStorage.setItem('selectedFields', JSON.stringify(newValue));
            },
            deep: true // Enable deep watching to detect changes in nested properties
        }
    },
    methods: {
        handleDateChange(type, date) {
            console.log(`Date changed for ${type}:`, date);
            // Handle the date change logic here
        },
        validateSelectedFields() {
            const defaultFields = this.getDefaultSelectedFields();
            Object.keys(defaultFields).forEach(key => {
                if (!Array.isArray(this.selectedFields[key])) {
                    this.selectedFields[key] = defaultFields[key];
                }
            });
            this.saveSelectedFields();
        },
        handleCheckboxChange(groupId, itemId, event) {
            const isChecked = event.target.checked;

            if (!this.selectedFields[groupId]) {
                this.$set(this.selectedFields, groupId, []); // Initialize the array if it doesn't exist
            }

            if (isChecked) {
                if (!this.selectedFields[groupId].includes(itemId)) {
                    this.selectedFields[groupId].push(itemId);
                }
            } else {
                this.selectedFields[groupId] = this.selectedFields[groupId].filter(id => id !== itemId);
            }

            this.saveSelectedFields();
        },
        country: [],
        clear(groupId) {
            this.selectedFields[groupId] = []; // Reset the selected items for the group directly
            this.saveSelectedFields(); // Optional: Save the updated selection state
        },
        getDefaultSelectedFields() {
            return {
                dataScope: [],
                is_hvd: [],
                hvdCategory: [],
                country: [],
                catalog: [],
                superCatalog: [],
                categories: [],
                publisher: [],
                keywords: [],
                dataServices: [],
                scoring: [],
                format: [],
                license: [],
                subject: []
            };
        },
        resetSelectedFields() {
            this.selectedFields = this.getDefaultSelectedFields();
            sessionStorage.setItem('selectedFields', JSON.stringify(this.selectedFields));
        },
        saveSelectedFields() {
            sessionStorage.setItem('selectedFields', JSON.stringify(this.selectedFields));
        },
        isNil,
        ...mapActions("datasets", [
            "loadDatasets",
            "loadAdditionalDatasets",
            "setPage",
            "addFacet",
            "removeFacet",
            "setFacets",
            "setFacetOperator",
            "setFacetGroupOperator",
            "setDataServices",
            "setPageCount",
            "setLimit",
            "setLoading",
            "setDataScope",
        ]),
        has,
        isArray,
        truncate,
        getTranslationFor,
        getImg,
        initDataScope() {
            this.setDataScope(this.dataScope);
        },
        showOptions() {
            this.open = true;
        },
        initPage() {
            const page = parseInt(this.$route.query.page, 10);
            if (page > 0) this.setPage(page);
            else this.setPage(1);
        },
        away() {
            this.open = false;
        },
        initFacets() {
            const fields = this.$env.content.datasets.facets.defaultFacetOrder;
            for (const field of fields) {
                this.facetFields.push(field);
                // catalog is not in route.query anymore, so we have to add to facets differently
                if (field === 'catalog' && !isNil(this.$route.params.ctlg_id)) {
                    this.addFacet({ field, facet: this.$route.params.ctlg_id });
                }
                else if (!Object.prototype.hasOwnProperty.call(this.$route.query, [field])) {
                    this.$router
                        .replace({
                            query: Object.assign({}, this.$route.query, { [field]: [] }),
                        })
                        .catch((error) => {
                            console.error(error);
                        });
                } else {
                    for (const facet of this.$route.query[field]) {
                        // do not add duplicates!
                        if (!this.getFacets[field]?.includes(facet)) {

                            this.addFacet({ field, facet });
                        }
                    }
                }
            }
        },
        initFacetOperator() {
            // Always set facet operator to AND when in catalog details mode
            if (this.showCatalogDetails)
                this.setFacetOperator("AND");
            else {
                const op = this.$route.query.facetOperator;
                if (op === "AND" || op === "OR") this.setFacetOperator(op);
            }
        },
        initFacetGroupOperator() {
            // The facetGroupOperator should be the same as the facetOperator
            // Always set facet operator to AND when in catalog details mode
            if (this.showCatalogDetails)
                this.setFacetGroupOperator("AND");
            else {
                const op = this.$route.query.facetOperator;
                if (op === "AND" || op === "OR") this.setFacetGroupOperator(op);
            }
        },
        initDataServices() {
            const ds = this.$route.query.dataServices;
            if (ds === "true" || ds === "false") this.setDataServices(ds);
            else {
                this.setDataServices("false");
            }
        },
        initDatasets() {
            this.$nextTick(() => {
                this.$nextTick(() => {
                    this.$Progress.start();
                    this.loadDatasets({ locale: this.$route.query.locale })
                        .then(() => {
                            this.setPageCount(
                                Math.ceil(this.getDatasetsCount / this.getLimit)
                            );
                            this.$Progress.finish();
                            $('[data-toggle="tooltip"]').tooltip({
                                container: "body",
                            });
                        })
                        .catch(() => this.$Progress.fail())
                        .finally(() => this.$root.$emit('contentLoaded'));
                });
            });
        },
        back() {
            // this.$router.push({ name: 'Datasets' });

            this.$router.go(-1)
            // dont clear saved parameters from before
        },
        setActive(field) {
            this.activeField = field;
        },
        clearInput() {
            event.preventDefault();
            this.query = '';
            this.titleQuery = '';
            this.descQuery = '';
            this.activeField = null;
            this.selectedOption = 'all',

                // Clear session storage for queries
                sessionStorage.removeItem('query');
            sessionStorage.removeItem('titleQuery');
            sessionStorage.removeItem('descQuery');
            this.resetSelectedFields();

            this.getAllAvailableFacets.forEach(group => {
                // Directly assign an empty array to each group ID in selectedFields
                this.selectedFields[group.id] = [];
            });
        },
        clearAll() {
            this.clearInput()
            window.scrollTo({
                top: 0,
                left: 0,
                behavior: 'smooth'
            });
        },
        handleEmpty(field) {
            if (this[field] === '') {
                this.clearInput()
            }
        },
        applySearch() {
            if (this.titleQuery) {
                const url = {
                    path: '/datasets',
                    query: {
                        locale: 'en',
                        query: this.titleQuery,
                        fields: 'title.*', // NEED TO add this to our main load function
                        page: 1,
                        filter: this.selectedOption,
                        ...this.selectedFields,

                    }
                };
                this.$router.push(url);
            } else if (this.descQuery) {
                const url = {
                    path: '/datasets',
                    query: {
                        locale: 'en',
                        query: this.descQuery,
                        fields: 'description.*', // NEED TO add this to our main load function
                        page: 1,
                        filter: this.selectedOption,
                        ...this.selectedFields,
                    }
                };
                this.$router.push(url);
            } else if (this.query) {
                const url = {
                    path: '/datasets',
                    query: {
                        locale: 'en',
                        query: this.query,
                        page: 1,
                        filter: this.selectedOption,
                        ...this.selectedFields,
                    }
                };
                this.$router.push(url);
            } else {
                const url = {
                    path: '/datasets',
                    query: {
                        locale: 'en',
                        page: 1,
                        filter: this.selectedOption,
                        ...this.selectedFields,
                    }
                };
                this.$router.push(url);
            }

        },
        selectOption(value) {
            this.selectedOption = value;
        },
        getLocalizedTitle(title) {
            if (typeof title === 'object') {
                // If title is an object, return the value for the current locale
                return title[this.locale] || title.en || 'N/A'; // Fallback to 'en' or 'N/A'
            }
            // If title is a string, return it as-is
            return title;
        },
        filteredItems(group) {
            const searchQuery = this.searchQueries[group.id]?.toLowerCase() || '';
            return group.items.filter(item => {
                const title = this.getLocalizedTitle(item.title).toLowerCase();
                return title.includes(searchQuery);
            });
        },
        toggleDropdown(groupId) {
            this.openDropdowns[groupId] = !this.openDropdowns[groupId];
        },

        closeAllDropdowns() {
            Object.keys(this.openDropdowns).forEach(key => {
                this.openDropdowns[key] = false;
            });
        },
        chunkArray(array, size) {
            const chunks = [];
            for (let i = 0; i < array.length; i += size) {
                chunks.push(array.slice(i, i + size));
            }
            return chunks;
        },

        getSelectedLabels(group) {
            return this.selectedFields[group.id]
                .map(id => {
                    const item = group.items.find(item => item.id === id);
                    return this.getLocalizedTitle(item.title);
                })
                .join(', ');
        }
    },
    created() {
        this.initDataScope();
        this.initPage();
        this.initDataServices();
        this.initFacets();
        this.initDatasets();

        setTimeout(() => {
            $(".facets-show-more").each(function () {
                $(this).click(function () {
                    $('body').tooltip({ selector: '[data-toggle="tooltip"]' });
                });
            });
        }, 1500);

        // Get 'query' from sessionStorage
        const storedQuery = sessionStorage.getItem('query') || '';
        this.query = storedQuery;

        const storedFilter = sessionStorage.getItem('selectedFields');
        this.selectedFields = storedFilter ? JSON.parse(storedFilter) : this.getDefaultSelectedFields();

        this.validateSelectedFields();

        window.addEventListener('click', (e) => {
            const dropdowns = document.querySelectorAll('.multiselect-container');
            let clickedOutside = true;

            dropdowns.forEach(dropdown => {
                if (dropdown.contains(e.target)) {
                    clickedOutside = false;
                }
            });

            if (clickedOutside) {
                this.closeAllDropdowns();
            }
        });

    }
};
</script>

<style lang="scss" scoped>
.container {
    padding: 30px 20px 20px 15px !important;
}

.btn-group .btn {
    font-weight: 300;
    border: 1px solid;
}

.active {
    font-weight: 700 !important;
}

.count-badge {
    padding: 3px;
    margin-left: 5px;
    color: #0E47CB;
    border: 1px solid #0E47CB;
    border-radius: 30px;
    background-color: #fff;

}

.back-btn {
    font-weight: 500;
    padding: 13px;
}

.btn-more {
    font-weight: 500;

    a:hover {
        text-decoration: none;
        color: #fff;
    }
}

.btn-more:hover {
    a {
        text-decoration: none;
        color: #fff;
    }
}

.back-btn svg {
    margin-bottom: 2px;
    margin-right: 5px;
}

.btn svg {
    vertical-align: text-top
}

h2 {
    font-size: 20px;
    font-weight: 700;
}

h2 svg {
    margin-right: 5px;
    vertical-align: baseline;
}

h3 {
    font-weight: 600;
    font-size: 16px;
}

.info-box {
    background-color: #F4F4F4;
    padding: 15px;
    border-radius: 4px;
    height: auto;
    color: #363636;
    max-height: 265px;
    margin-top: 80px;
}

.details {
    list-style-type: none;
    margin-left: 5px;
    line-height: 30px;
}

.box {
    background-color: #FBFBFB;
    padding: 25px;
    border-radius: 4px;
}

.label {
    font-weight: 700;
}

.text {
    padding: 10px;
    min-width: 500px;
    border: 0.4px solid #CDCDCD;
    border-radius: 4px;
}

.filled-input {
    border: 2px solid #0e47cb;
    /* Small blue border */
}

.date input {
    min-width: 100px;
}

::placeholder {
    color: #acacac;
}



/* Multi Select */
.facets-row {
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    gap: 20px;
    margin-bottom: 20px;

    .facet-group {
        min-width: 0;
    }

    .multiselect-container {
        width: 100%;
        max-width: none;
    }
}

.facet-row {
    display: flex;
    gap: 7%;
    margin-bottom: 16px;
}



.facet-label {
    font-weight: 700;
    margin-top: 25px;
}

.multiselect-container {
    position: relative;
    width: 100%;
    max-width: 300px;
}

.multiselect-trigger {
    padding: 0px 0px 0px 10px;
    border: 1px solid #CDCDCD;
    border-radius: 4px;
    cursor: pointer;
    display: flex;
    justify-content: space-between;
    align-items: center;
    background: white;
    width: 300px;
    min-height: 48px;
    border-color: #707070;

    &:hover {
        border-color: #0e47cb;
    }
}

.multiselect-wrapper {
    position: absolute;
    top: 100%;
    left: 0;
    right: 0;
    border-top: none;
    border: 1px solid #CDCDCD;
    border-radius: 0px 0px 4px 4px;
    background: white;
    box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
    z-index: 1000;
    width: 300px;
}

.ecl-select__icon {
    border-top-right-radius: 4px;
    border-bottom-right-radius: 4px;
}

.trigger-content {
    flex: 1;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
    display: -webkit-box;
    -webkit-line-clamp: 1;
    -webkit-box-orient: vertical;
    overflow: hidden;
    white-space: nowrap;
}

.filter-badge {
    align-items: center;
    background-color: #0e47cb;
    border-radius: .75rem;
    color: #fff;
    display: inline-flex;
    height: auto;
    justify-content: center;
    min-width: 35px;
    padding: .25rem;
    position: relative;
    text-align: center;
    margin-right: 5px;

}

.multiselect-search {
    padding: 8px;
    border: none;
    width: -webkit-fill-available;
    margin: 10px;
    border-radius: 5px;
    border: 1px solid #707070;
    box-shadow: 0 2px 4px #09318e14 inset, 0 0 10px #09318e0a inset, 0 4px 5px #09318e0a inset, 0 -4px 4px #09318e0a inset;
    border-radius: 4px 4px 4px 4px;
    width: 280px;
    margin: 10px;
}

.multiselect-dropdown {
    color: #3f3f3f;
    max-height: 300px;
    overflow-y: auto;
    background: white;
    border-radius: 0 0 4px 4px;
    border-top: solid 1px #dadada;
}

.multiselect-item {
    padding: 8px;
    cursor: pointer;

    &:hover {
        background-color: #f5f5f5;
    }
}

.checkbox-container {
    display: flex;
    align-items: center;
    gap: 8px;
    cursor: pointer;
}

.checkbox-container input {
    min-width: auto;
    margin-left: 10px;
}

.checkbox-label {
    flex: 1;
}

.btn-container {
    border-top: 1px solid #dadada;
    padding: 10px;
}

.select-custom {
    margin-top: 10px;
    width: 100%;

}

// Radio design

.radio {
    background-color: #fff;
    border: solid 1px #707070;
    min-height: 48px;
    padding: 8px;
    border-radius: 4px;
    width: 300px;
    display: flex;
    justify-content: space-between;
    align-items: center;
}

.radio-options label {
    margin-bottom: 0px;
    margin-right: 20px;
}

.debug {
    position: fixed;
    right: 20px;
    top: 20px;
    border-radius: 20px;
    width: 400px;
    z-index: 999999;
    padding: 20px;
    background: rgba(255, 255, 255, 0.2);
    border-radius: 16px;
    box-shadow: 0 4px 30px rgba(0, 0, 0, 0.1);
    backdrop-filter: blur(5px);
    -webkit-backdrop-filter: blur(5px);
    border: 1px solid rgba(255, 255, 255, 0.3);
    display: none;
}
</style>